//------------------------------------------------------------------
// original ised and first implementation by mony
// tris version by mladen
//------------------------------------------------------------------
#property copyright "mony & mladen"
#property link      "made at www.forex.tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 LimeGreen
#property indicator_color2 Orange
#property indicator_color3 LimeGreen
#property indicator_color4 Orange
#property indicator_color5 Orange
#property indicator_width3 3
#property indicator_width4 3
#property indicator_width5 3
#property strict

//
//
//
//
//
//

enum enDisplay
{
   dis_line, // Display colored line
   dis_bars, // Display colored bars
   dis_both  // Display both colored lines and bars
};

extern int                CCIperiod       = 3;              // CCI period
extern int                ATRperiod       = 300;            // ATR period
extern ENUM_APPLIED_PRICE applied_price   = PRICE_TYPICAL;  // Price to use
extern enDisplay          DisplayType     = dis_line;       // Display type
extern bool               alertsOn        = true;           // Turn alerts on
extern bool               alertsOnCurrent = false;          // Alerts on current (still opened) bar
extern bool               alertsMessage   = true;           // Alerts should display pop-up message
extern bool               alertsSound     = false;          // Alerts should play sound
extern bool               alertsNotify    = false;          // Alerts should send notification
extern bool               alertsEmail     = false;          // Alerts should send enail
extern string             soundFile       = "alert2.wav";   // Sound file t use for sound alerts

double TrLine[];
double TrendDowna[];
double TrendDownb[];
double HistUp[];
double HistDn[];
double trend[];



//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   int styleLine = DRAW_LINE;      if (DisplayType==dis_bars) styleLine=DRAW_NONE;
   int styleBars = DRAW_HISTOGRAM; if (DisplayType==dis_line) styleBars=DRAW_NONE;
   SetIndexBuffer(0, HistUp);     SetIndexStyle(0,styleBars);
   SetIndexBuffer(1, HistDn);     SetIndexStyle(1,styleBars);
   SetIndexBuffer(2, TrLine);     SetIndexStyle(2,styleLine);
   SetIndexBuffer(3, TrendDowna); SetIndexStyle(3,styleLine);
   SetIndexBuffer(4, TrendDownb); SetIndexStyle(4,styleLine);
   SetIndexBuffer(5, trend);
   return(0);
}
int deinit(){ return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
 
   //
   //
   //
   //
   //
   
   if (trend[limit]==-1) CleanPoint(limit,TrendDowna,TrendDownb);  
   for(int i=limit; i >= 0; i--) 
   {
      double cciTrendNow = iCCI(NULL, 0, CCIperiod, applied_price, i);
      if (cciTrendNow >= 0) 
         {
            TrLine[i] = NormalizeDouble(Low[i] - iATR(NULL, 0, ATRperiod, i),Digits);    
               if (i<(Bars-1) && TrLine[i] < TrLine[i+1]) TrLine[i] = TrLine[i+1];
         }
         if (cciTrendNow <= 0) 
         {
            TrLine[i] = NormalizeDouble(High[i] + iATR(NULL, 0, ATRperiod, i),Digits);
               if (i<(Bars-1) && TrLine[i] > TrLine[i+1]) TrLine[i] = TrLine[i+1];
         }

         //
         //
         //
         //
         //
         
         TrendDowna[i] = EMPTY_VALUE;
         TrendDownb[i] = EMPTY_VALUE;
         if (i<(Bars-1))
         {
            trend[i] = trend[i+1];
               if (TrLine[i]> TrLine[i+1]) trend[i] = 1;
               if (TrLine[i]< TrLine[i+1]) trend[i] =-1;
               if (trend[i] == -1) PlotPoint(i,TrendDowna,TrendDownb,TrLine);
               if (trend[i] ==  1) { HistUp[i] = High[i]; HistDn[i] = Low[i]; }
               if (trend[i] == -1) { HistDn[i] = High[i]; HistUp[i] = Low[i]; }
         }
   }              
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" SP MY trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(Symbol()+" S P MY",message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}